#include "uihelper.h"
#include "licensemodel.h"
#include "easylogging++.h"

// #include <DFontSizeManager>

#include <QMenu>
#include <QApplication>
#include <QContextMenuEvent>
#include <QDebug>
#include <QTimer>
#include <QDBusInterface>
#include <QDBusReply>
#include <QClipboard>
#include <QPainter>
#include <QProcess>

extern "C" {
#include "qrencode.h"
}

QMainWindow *CommonMethods::windowWidget = Q_NULLPTR;
qint32 CommonMethods::maxHeight = 0;
qint32 CommonMethods::currentHeight = 0;
QString CommonMethods::g_product_label = "";
QString CommonMethods::g_product_name = "";

//QString CommonMethods::g_online_url        = "http://172.30.81.226:81";
//QString CommonMethods::g_online_qrcode_url = "http://172.30.81.226:81/api/product/start-product-qr-code/";

QString CommonMethods::g_online_url        = "http://172.30.113.92:8011";
QString CommonMethods::g_online_qrcode_url = "http://172.30.113.92:8011/api/product/start-product-qr-code/";

constexpr double ERRORVALUE = 2;
constexpr int SERIALLENGTHSP1 = 19;
constexpr int SERIALLENGTHSP2 = 29;

//KeyDLineEdit::KeyDLineEdit(QWidget *parent)
//    : DLineEdit(parent)
//{
//    m_isKeyPaste = false;
//    m_isBackspace = false;
//    m_isSerialSixteen = false;
//    m_isEditable = true;
//    m_activateNowButton = nullptr;
//    this->lineEdit()->setAcceptDrops(false);
//    initUi();
//    connect(this, &KeyDLineEdit::textEdited, this, &KeyDLineEdit::serialEditChange);
//}

////获取上下文菜单paste点击
//bool KeyDLineEdit::eventFilter(QObject *watched, QEvent *event)
//{
//    if (watched == this->lineEdit()) {
//        if (event->type() == QEvent::KeyPress) {
//            QKeyEvent *keyEvent = static_cast<QKeyEvent *>(event);
//            if (keyEvent->key() == Qt::Key_Backspace) {
//                m_isBackspace = true;
//            }
//            if ((keyEvent->modifiers() == Qt::ControlModifier) && (keyEvent->key() == Qt::Key_Backspace)) {
//                this->clear();
//                if (nullptr != m_activateNowButton)
//                    m_activateNowButton->setEnabled(false);

//                return true;
//            } else if ((keyEvent->modifiers() == Qt::ControlModifier) && (keyEvent->key() == Qt::Key_V)) {
//                m_isKeyPaste = true;
//            } else if (keyEvent->key() == Qt::Key_Minus) {
//                return true;
//            }
//        }

//        if (event->type() == QEvent::MouseButtonRelease) {
//            QMouseEvent *mouseEvent = static_cast<QMouseEvent *>(event);
//            if (mouseEvent->button() == Qt::MidButton) {
//                return true;
//            }
//        }

//        if (event->type() == QEvent::ContextMenu) {
//            if (QMenu *menu = lineEdit()->createStandardContextMenu()) {
//                menu->setAttribute(Qt::WA_DeleteOnClose);
//                menu->popup(QCursor::pos());
//                menu->connect(menu, &QMenu::triggered, this, [ = ](QAction * action) {
//                    //上下文菜单 点击粘贴
//                    if (action->text().contains("&P"))
//                        m_isKeyPaste = true;
//                });
//            }
//        }
//    }

//    return QWidget::eventFilter(watched, event);
//}

//QString KeyDLineEdit::textSeparator(const QString &sumText)
//{
//    QString currentText = sumText.toUpper();
//    m_cursorPosition = this->lineEdit()->cursorPosition();

//    if (m_isBackspace && (m_lastText[m_cursorPosition] == '-')) {
//        m_cursorPosition = m_cursorPosition - 1;
//        currentText = currentText.remove(m_cursorPosition, 1);
//    }

//    QString serialText = currentText.remove(QChar('-'), Qt::CaseInsensitive);

//    if (serialText.length() > 16)
//        m_isSerialSixteen = false;
//    else
//        m_isSerialSixteen = true;

//    int separate = 1;
//    for (int i = 0; i <= sumText.length(); ++i) {
//        if (separate == 5) {
//            serialText = serialText.left(SERIALLENGTHSP2);
//            break;
//        }
//        if (sumText.length() <= SERIALLENGTHSP1) {
//            if (i == (4 * separate + separate - 1)) {
//                serialText.insert(i, '-');
//                separate++;
//            }
//        } else {
//            if (i == ((5 * separate) + (separate - 1))) {
//                serialText.insert(i, '-');
//                separate++;
//            }
//        }
//    }

//    while (serialText.endsWith('-'))
//        serialText.chop(1);

//    m_isBackspace = false;
//    return serialText;
//}

//int KeyDLineEdit::textCursorPos(const QString &currentText, const QString &newText)
//{
//    int currentPos = m_cursorPosition;
//    QString currentPosText = currentText.left(currentPos);
//    QString newPostext = newText.left(currentPos);

//    if (currentText.length() > m_lastText.length()) {
//        if (m_isKeyPaste) {
//            int keylen = currentPos - currentPosText.count('-');
//            int pos = keylen >= 16 ? (keylen / 5) : (keylen / 4);
//            currentPos = currentPos + (pos - currentPosText.count('-'));
//            m_isKeyPaste = false;
//        } else {
//            int movepos = newPostext.count('-') - currentPosText.count('-');

//            if (newPostext.endsWith('-') && (movepos == 0))
//                currentPos = currentPos - 1;
//            else
//                currentPos = currentPos + movepos;

//            if (m_isSerialSixteen) {
//                if (currentPos == 5 || currentPos == 10 || currentPos == 15) {
//                    currentPos = currentPos + 1;
//                }
//            } else {
//                if (currentPos == 6 || currentPos == 12 || currentPos == 18 || currentPos == 24) {
//                    currentPos = currentPos + 1;
//                }
//            }
//        }
//    } else if (currentText.length() < m_lastText) {
//        currentPos = currentPos + (newPostext.count('-') - currentPosText.count('-'));
//    } else {
//    }

//    return currentPos;
//}

//void KeyDLineEdit::checkSerialValid(QString &key)
//{
//    int pos = 0;
//    QRegExpValidator charValid(QRegExp("^[-A-Za-z0-9]+$"));
//    bool keyValid = !((charValid.validate(key, pos) != QValidator::Acceptable));

//    if (!keyValid && !key.isEmpty()) {
//        this->setAlert(true);
//        QTimer::singleShot(1000, [ = ]() { this->setAlert(false); });
//        this->showAlertMessage(tr("Special characters are not allowed"), 1000);
//        key = key.remove(QRegExp("[^A-Za-z0-9]"));
//    }

//    if (SERIALLENGTHSP2 < key.length()) {
//        //超出25位激活码提示信息产品待确认
//        // this->showAlertMessage(tr("Character length required is 25"), 1000);
//        if (m_lastText.length() == SERIALLENGTHSP2) {
//            m_isEditable = false;
//        }
//    }

//    if (nullptr == m_activateNowButton)
//        return;

//    if (this->text().length() == SERIALLENGTHSP1 || this->text().length() >= SERIALLENGTHSP2) {
//        m_activateNowButton->setEnabled(true);
//    } else {
//        m_activateNowButton->setEnabled(false);
//    }
//}

//void KeyDLineEdit::serialEditChange(const QString &key)
//{
//    QString text = key;
//    checkSerialValid(text);

//    if (text.isEmpty()) {
//        m_lastText.clear();
//        this->lineEdit()->clear();
//        return;
//    }

//    if (!m_isEditable) {
//        m_isEditable = true;
//        this->lineEdit()->setText(m_lastText);
//        return;
//    }

//    QString sepliterText = textSeparator(text);
//    int32_t resetCursorPos = textCursorPos(text, sepliterText);
//    this->lineEdit()->setText(sepliterText);
//    this->lineEdit()->setCursorPosition(resetCursorPos);
//    m_lastText = sepliterText;
//    checkSerialValid(text);
//}

//void KeyDLineEdit::activeButton(DSuggestButton *button)
//{
//    m_activateNowButton = button;
//}

//void KeyDLineEdit::initUi()
//{
//    setContextMenuPolicy(Qt::CustomContextMenu);
//    this->setMinimumHeight(buttonHeight);
//    DFontSizeManager::instance()->bind(this->lineEdit(), DFontSizeManager::T6);
//    this->setClearButtonEnabled(false);
//    this->lineEdit()->installEventFilter(this);
//}

void QRCodeLabel::generateQRCode(const QString &url)
{
    //生成二维码,二维码数据,二维码图像是25x25 QR_ECLEVEL_Q 容错等级
    QRcode *qrcode = QRcode_encodeString(url.toStdString().c_str(), 2, QR_ECLEVEL_L, QR_MODE_8, 1);
    if (!qrcode) {
        LOG(INFO) << "qrcode point is null";
        return;
    }

    if (0 >= qrcode->width) {
        LOG(INFO) << "qrcode width Less than 1";
        QRcode_free(qrcode);
        return;
    }

    qint32 qrcodeWidth = qrcode->width;
    LOG(INFO) << "qrcodeWidth" << qrcodeWidth;
    double scaleX = static_cast<double>(width()) / static_cast<double>(qrcodeWidth);
    double scaleY = static_cast<double>(height()) / static_cast<double>(qrcodeWidth);
    QPixmap pixmap = QPixmap(width(), height());
    QPainter painter(&pixmap);
    QColor background(Qt::white);
    painter.setBrush(background);
    painter.setPen(Qt::NoPen);
    painter.drawRect(0, 0, width() + 2, height() + 2);
    QColor foreground(Qt::black);
    painter.setBrush(foreground);
    for (qint32 y = 0; y < qrcodeWidth; y++) {
        for (qint32 x = 0; x < qrcodeWidth; x++) {
            unsigned char data = qrcode->data[y * qrcodeWidth + x];
            if (data & 0x01) {
                QRectF r(x * scaleX, y * scaleY, scaleX, scaleY);
                painter.drawRects(&r, 1);
            }
        }
    }
    this->setPixmap(pixmap);
    QRcode_free(qrcode);
}

void ManualHelper::openManual()
{
    QDBusInterface manual("com.deepin.Manual.Open", "/com/deepin/Manual/Open", "com.deepin.Manual.Open",
                          QDBusConnection::sessionBus());
    QDBusReply<void> reply = manual.call("OpenTitle", "dde", "License activator");
    if (reply.isValid()) {
        LOG(INFO) << "call com.deepin.Manual.Open success";
        return;
    }
    LOG(INFO) << "call com.deepin.Manual.Open failed";
}

double CommonMethods::getRemainingWidth(const double &maxLength, const QFont &fontSize, const QString &string)
{
    QFontMetricsF stringFontMetrics(fontSize);
    double stringValueWidth = stringFontMetrics.width(string);
    if (stringValueWidth >= maxLength)
        return -1;

    return ((maxLength - stringValueWidth) - ERRORVALUE);
}

QString CommonMethods::returnNewlineString(QString oldStr, double maxLength, QFontMetricsF &oldFontMetricsF,
                                           qint32 &lineBreaks)
{
    double valueTipLabelWidth;
    qint32 lineBreakPoszition = 0;
    QString newLineStr = oldStr.remove('\n');
    qint32 endlessLoop = 0;
    // 10表示换行次数
    while (endlessLoop < 10) {
        QString oldStrTemp;
        for (int i = lineBreakPoszition; i < newLineStr.length(); i++)
            oldStrTemp.append(newLineStr[i]);

        valueTipLabelWidth = oldFontMetricsF.width(oldStrTemp);
        if (valueTipLabelWidth < maxLength)
            break;

        QString newLineStrTemp;
        double newLineWith = 0;
        for (int j = lineBreakPoszition; j < newLineStr.length(); j++) {
            newLineStrTemp.append(newLineStr[j]);
            newLineWith = oldFontMetricsF.width(newLineStrTemp);

            if (newLineWith >= maxLength) {
                newLineStr.insert(j, '\n');
                lineBreakPoszition = j + 1;
                lineBreaks++;
                break;
            }
        }

        endlessLoop++;
    };

    return newLineStr;
}

void CommonMethods::setMainWindow(QMainWindow *widget)
{
    CommonMethods::windowWidget = widget;
}

qint32 CommonMethods::getMainWindowWidth()
{
    return CommonMethods::windowWidget->width();
}

qint32 CommonMethods::getMainWindowHeight()
{
    return CommonMethods::windowWidget->height();
}

void CommonMethods::setMainWindowSize(const QSize &size)
{
    if (CommonMethods::windowWidget) {
        if (size.height() > maxHeight) {
            CommonMethods::windowWidget->setFixedSize(size.width(), maxHeight);
            currentHeight = maxHeight;
        } else {
            CommonMethods::windowWidget->setFixedSize(size);
            currentHeight = size.height();
        }
    } else {
        LOG(INFO) << "widget is NULL";
    }
}

void CommonMethods::setMainWindowMaxHeight(int dockPosition, int dockHeight, int displayWidth, int displayHeight)
{
    maxHeight = displayHeight;
    if (CommonMethods::windowWidget) {
        if (CommonMethods::windowWidget->height() >= displayHeight) {
            CommonMethods::windowWidget->setFixedHeight(displayHeight);
        } else if ((CommonMethods::windowWidget->height() <= displayHeight) && (currentHeight >= displayHeight)) {
            CommonMethods::windowWidget->setFixedHeight(currentHeight);
        } else {
            //do nothing
        }

        if (dockPosition == DockPosition::Left) {
            if (CommonMethods::windowWidget->x() < dockHeight)
                CommonMethods::windowWidget->move(dockHeight, CommonMethods::windowWidget->y());
        } else if (dockPosition == DockPosition::Right) {
            if ((CommonMethods::windowWidget->x() + CommonMethods::windowWidget->width()) > displayWidth)
                CommonMethods::windowWidget->move(displayWidth - CommonMethods::windowWidget->width(),
                                                  CommonMethods::windowWidget->y());
        } else if (dockPosition == DockPosition::Top) {
            if (CommonMethods::windowWidget->y() <= dockHeight )
                CommonMethods::windowWidget->move(CommonMethods::windowWidget->x(), dockHeight);
        } else if (dockPosition == DockPosition::Bottom) {
            if ((CommonMethods::windowWidget->height() + CommonMethods::windowWidget->y()) > displayHeight)
                CommonMethods::windowWidget->move(CommonMethods::windowWidget->x(), 0);
        } else {
            //do nothing
        }
    }
}

QString CommonMethods::getProductLabel() {
    return g_product_label;
}
void CommonMethods::setProductLabel(const QString &product_label) {
    g_product_label = product_label;
}

QString CommonMethods::getProductName() {
    return g_product_name;
}
void CommonMethods::setProductName(const QString &product_name) {
    g_product_name = product_name;
}

QString CommonMethods::getOnlineUrl() {
    return g_online_url;
}

QString CommonMethods::getOnlineUrlodeUrl() {
    return g_online_qrcode_url;
}
