#pragma once

#include "licensemodel.h"

// #include <DSuggestButton>
#include <QLineEdit>
#include <QMainWindow>

#include <QWidget>
#include <QBoxLayout>
#include <QLabel>
#include <QValidator>
#include <QMouseEvent>

// DWIDGET_USE_NAMESPACE

#define APPEARANCE_SERVICE_NAME "com.deepin.daemon.Appearance"
#define APPEARANCE_SERVICE_PATH "/com/deepin/daemon/Appearance"
#define APPEARANCE_INTERFACE_NAME "com.deepin.daemon.Appearance"

class CommonMethods
{
public:
    static double getRemainingWidth(const double &maxLength, const QFont &fontSize, const QString &string);
    static QString returnNewlineString(QString oldStr, double maxLength, QFontMetricsF &oldFontMetricsF,
                                       qint32 &lineBreaks);
    static void setMainWindow(QMainWindow *widget);
    static qint32 getMainWindowWidth();
    static qint32 getMainWindowHeight();
    static void setMainWindowSize(const QSize &size);
    static void setMainWindowMaxHeight(qint32 dockPosition, qint32 dockHeight, qint32 displayWidth, qint32 displayHeight);

    static QString getProductLabel();
    static void setProductLabel(const QString &product_label);
    static QString getProductName();
    static void setProductName(const QString &product_name);

    static QString getOnlineUrl();
    static QString getOnlineUrlodeUrl();

private:
    static QMainWindow *windowWidget;
    static qint32 maxHeight;
    static qint32 currentHeight;

    static QString g_product_label;
    static QString g_product_name;

    static QString g_online_url;
    static QString g_online_qrcode_url;

};

class QRCodeLabel : public QLabel
{
    Q_OBJECT
public:
    void generateQRCode(const QString &url);
};

class ManualHelper : public QObject
{
    Q_OBJECT
public slots:
     static void openManual();
};

//add filter contextMenu
//class KeyDLineEdit : public QLineEdit
//{
//    Q_OBJECT
//public:
//    explicit KeyDLineEdit(QWidget *parent = Q_NULLPTR);
//    bool eventFilter(QObject *watched, QEvent *event) Q_DECL_OVERRIDE;

//public slots:
//    void serialEditChange(const QString &key);
//    void activeButton(DSuggestButton *button);

//private:
//    void initUi();
//    QString textSeparator(const QString &sumText);
//    int textCursorPos(const QString &currentText, const QString &newText);
//    void checkSerialValid(QString &key);

//    bool m_isKeyPaste;
//    bool m_isSerialSixteen;
//    bool m_isBackspace;
//    bool m_isEditable;
//    qint32 m_cursorPosition = 0;
//    QString m_lastText;
//    QString m_pasteText;
//    QString m_clipText;
//    DSuggestButton *m_activateNowButton;
//};
