#ifndef ACTIVE_STATUS_H
#define ACTIVE_STATUS_H

#include <QWidget>
#include <QTimer>

namespace Ui {
class active_status;
}

class active_status : public QWidget
{
    Q_OBJECT

public:
    explicit active_status(QWidget *parent = 0);
    ~active_status();

    void init(bool bret, const QString msg);
    void run();

private slots:
    void on_pushButton_clicked();
    void on_timer_timeout();

private:
    Ui::active_status *ui;
    QTimer* m_pTimer = nullptr;
    int m_startValue = 0;
};

#endif // ACTIVE_STATUS_H
