#include "failed-widget.h"
#include "uihelper.h"
#include <iostream>

namespace {

} // namespace

FailedWidget::FailedWidget(QWidget *parent)
    : QWidget(parent) {
    initUI();
    initConnection();
}

FailedWidget::~FailedWidget() {
}

void FailedWidget::initUI() {
    setupUi(this);

    mProductContent->setText(CommonMethods::getProductName());
}

void FailedWidget::initConnection() {
    connect(mReturnBtn, SIGNAL(clicked()),
            this, SLOT(onFailedReturnBtnClicked()));
}

void FailedWidget::onFailedReturnBtnClicked() {
    std::cout << "onFailedReturnBtnClicked" << std::endl;
    emit failedReturnBtnClicked();
}

void FailedWidget::updateView(const LicenseModel &model) {
    mProductContent->setText(model.license.product_name);
}
