#include "formloading.h"
#include "ui_formloading.h"
#include <QMovie>
#include <QBitmap>
#include <QPainter>

FormLoading::FormLoading(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::FormLoading)
{
    ui->setupUi(this);

    QBitmap bmp(this->size());
    bmp.fill();
    QPainter paint(&bmp);
    paint.setPen(Qt::NoPen);
    paint.setBrush(Qt::black);
    paint.drawRoundedRect(bmp.rect(), 6, 6);
    setMask(bmp);

    static QMovie move("://icons/deepin/builtin/icons/icon_loading.gif");
    ui->label->setMovie(&move);
    move.setScaledSize(ui->label->size());
    move.start();

    hide();
}

FormLoading::~FormLoading()
{
    delete ui;
}
