#include "information_widget.h"
#include "ui_information_widget.h"
#include <QPainter>
#include <QDesktopWidget>
#include <QBitmap>

Information_widget::Information_widget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Information_widget)
{
    ui->setupUi(this);

    setWindowFlags(Qt::FramelessWindowHint | Qt::Dialog);
    setWindowModality(Qt::WindowModal);
    QBitmap bmp(this->size());
    bmp.fill();
    QPainter paint(&bmp);
    paint.setPen(Qt::NoPen);
    paint.setBrush(Qt::black);
    paint.drawRoundedRect(bmp.rect(), 12, 12);
    setMask(bmp);

    //QDesktopWidget *desktop = QApplication::desktop();
    //move((desktop->width() - this->width())/2, (desktop->height() - this->height())/2);

    ui->label_2->setText(ver);
}

Information_widget::~Information_widget()
{
    delete ui;
}

void Information_widget::on_pushButton_clicked()
{
    this->hide();
}
