#ifndef OFFLINE_INLINE_WIDGET_H
#define OFFLINE_INLINE_WIDGET_H

#include <QWidget>
#include "ui_offline-inline-widget.h"

class OfflineInlineWidget : public QWidget,
                    public Ui::OfflineInlineWidget
{
    Q_OBJECT
public:
    OfflineInlineWidget(QWidget *parent=0);
    ~OfflineInlineWidget();

    void initUI();
    void initConnection();
    void initialize();
    QString getMacAddress(bool deleteColon = false);

public slots:
    void onPreviousBtnClicked();
    void onOffActivateBtnClicked();

signals:
    void previousBtnClickedInline();
    void offActivateBtnClickedInline(const QString& serial_b);

private:

    Q_DISABLE_COPY(OfflineInlineWidget)
};

#endif // OFFLINE_ACTIVATED_WIDGET_H
