#ifndef REACT_ACTIVE_WIDGET_H
#define REACT_ACTIVE_WIDGET_H

#include <QWidget>
#include <QValidator>

namespace Ui {
class react_active_widget;
}

class react_active_widget : public QWidget
{
    Q_OBJECT

public:
    explicit react_active_widget(QWidget *parent = 0);
    ~react_active_widget();

    void init_react_active_widget(QString &url);
    void recover_style_sheet();

    bool Is_click = false;

private slots:
    void on_pushButton_back_clicked();

    void on_pushButton_offline_active_clicked();

    void on_lineEdit_offline_active_seq_textChanged(const QString &arg1);

    void on_lineEdit_offline_active_seq_2_textChanged(const QString &arg1);

    void on_lineEdit_offline_active_seq_3_textChanged(const QString &arg1);

    void on_lineEdit_offline_active_seq_4_textChanged(const QString &arg1);

private:
    Ui::react_active_widget *ui;
    QValidator* validator_a = nullptr;
    QValidator* validator_b = nullptr;
    QValidator* validator_c = nullptr;
    QValidator* validator_d = nullptr;
    QValidator* validator_e = nullptr;

    void generateQRCode(const QString& url);

signals:
    void react_offline_importSerialB(const QString& serial_b, const QString& product_name);
};

#endif // REACT_ACTIVE_WIDGET_H
