#ifndef SUCCESS_WIDGET_H
#define SUCCESS_WIDGET_H

#include <QWidget>
#include "ui_success-widget.h"
#include "licensemodel.h"

class SuccessWidget : public QWidget,
                    public Ui::SuccessWidget
{
    Q_OBJECT
public:
    SuccessWidget(QWidget *parent=0);
    ~SuccessWidget();
    void initConnection();
    void updateView(const LicenseModel &model);

public slots:
    void onConfirmBtnClicked();

signals:
    void confirmBtnClicked();

private:
    LicenseModel m_licenseModel;

    Q_DISABLE_COPY(SuccessWidget)
};

#endif // SUCCESS_WIDGET_H
