#include <QtWidgets>
#include <QPixmap>
#include <QImage>

#include "titlebar-widget.h"

namespace {

} // namespace

TitleBarWidget::TitleBarWidget(QWidget *parent)
    : QWidget(parent)
{
    setupUi(this);
    setupLogoAndBrand();

    mCloseBtn->setText("");
    mCloseBtn->setIcon(QIcon(":/icons/deepin/builtin/icons/close_btn.png"));
    connect(mCloseBtn, SIGNAL(clicked()), this, SIGNAL(hideMainwindow()));
}

TitleBarWidget::~TitleBarWidget()
{
}

void TitleBarWidget::setupLogoAndBrand() {
    // mLogo->setText("");
    // mLogo->setToolTip(getBrand());
    // QPixmap logo;
    // We must get the pixmap from a QImage, otherwise the logo won't be
    // updated when we switch between two accounts, one of which has custom
    // logo and the other doesn't.
    // logo.convertFromImage(QImage(":/icons/deepin/builtin/icons/logo.png"));
    // mLogo->setPixmap(logo);

    mBrand->setText("授权认证工具");
    // mBrand->setToolTip(getBrand());
}
