﻿#ifndef QSQLCIPHER_H
#define QSQLCIPHER_H

#include <QObject>
#include <QSqlDatabase>

class QSqlCipher : public QObject
{
    Q_OBJECT

public:
   QSqlCipher(const QString& dbPath, QObject *parent = Q_NULLPTR);
   ~QSqlCipher();

   bool init();
   bool IstableExist(const QString &sql);

   bool createTable(const QString &sql);
   bool insertData(const QString &sql);
   QSqlQuery getData(const QString &sql);

private:
   QString m_dbPath;
   QSqlDatabase m_db;
   QString m_connectionName;
};


#endif
