#ifndef NETWORKCONNECTIVITYCHECK_H
#define NETWORKCONNECTIVITYCHECK_H

#include <QObject>
#include <QEventLoop>
#include <QNetworkReply>
#include <QNetworkAccessManager>

class NetworkConnectivityCheck : public QObject
{
    Q_OBJECT
public:
    explicit NetworkConnectivityCheck(QObject *parent = nullptr);
    ~NetworkConnectivityCheck();
    int getNetworkStatus(QString url);
    bool getNetWorkInterfaceStatus();
    bool getIsEnter();

public slots:
    void quitEventLoop();

private:
    QNetworkAccessManager m_networkManager;
    QEventLoop m_eventLoop;
    bool m_isEnter = false;
};

#endif // NETWORKCONNECTIVITYCHECK_H
