#ifndef FAILED_WIDGET_H
#define FAILED_WIDGET_H

#include <QWidget>
#include "ui_failed-widget.h"
#include "licensemodel.h"

class FailedWidget : public QWidget,
                    public Ui::FailedWidget
{
    Q_OBJECT
public:
    FailedWidget(QWidget *parent=0);
    ~FailedWidget();
    void initUI();
    void initConnection();
    void updateView(const LicenseModel &model);

public slots:
    void onFailedReturnBtnClicked();

signals:
    void failedReturnBtnClicked();

private:

    Q_DISABLE_COPY(FailedWidget)
};

#endif // FAILED_WIDGET_H
