#ifndef QFFLINE_QRCODE_WIDGET_H
#define QFFLINE_QRCODE_WIDGET_H

#include <QWidget>
#include "ui_offline-qrcode-widget.h"

class OfflineQrcodeWidget : public QWidget,
                    public Ui::OfflineQrcodeWidget
{
    Q_OBJECT
public:
    OfflineQrcodeWidget(QWidget *parent=0);
    ~OfflineQrcodeWidget();

    void initUI();
    void initConnection();

    void generateQRCode(const QString& url);

public slots:
    void onReturnBtnClicked();
    void onNextBtnClicked();

signals:
    void returnBtnClicked();
    void nextBtnClicked();

private:
    Q_DISABLE_COPY(OfflineQrcodeWidget)
};

#endif // QFFLINE_QRCODE_WIDGET_H
