#ifndef LICENSEFILEOPERATE_H
#define LICENSEFILEOPERATE_H

#include "licensemodel.h"
#include <QDebug>

//#define SYSTEM_LICENSE "/var/nfs/.license.key"
//#define SYSTEM_LICENSE_PRESP1 "/var/deepin/.license.key"
//#define SYSTEM_TRIALINFO "/var/nfs/.trialinfo.key"
#define SERVER_CONF_BAK "/var/nfs/.license.json.bak"
#define SERVER_CONF "/var/lib/nfs-license/.license.json"
// #define SERVER_CONF "/home/nfs/zhouy/01-projects/01-nfs-license-activator/03-code/nfs-license-activator/src/agent/conf/.license.json"
#define CLIENT_VERIFY "/var/nfs/.verify.key"
#define ACTIVE_CODE "Y2016E0001"
#define AUTHCONF_PATH "/etc/apt/auth.conf.d/"
#define AUTHCONF_FILE "/etc/apt/auth.conf.d/uos.conf"

#define VALID_FOR_LIFE "9999999999"
#define UUID_LENGTH 24
#define TEMP_UUID_LENGTH 16
#define ECC_VERSION "v2"
#define SP1_MACHINECODE_LENGTH 19
#define SP2_LICENSE_FILE_LENGTH 11
#define SP3_LICENSE_FILE_LENGTH 13

#define PRESP1_LICENSE_FILE_LENGTH 6
#define SP1_LICENSE_FILE_LENGTH 9
#define SP1UPDATE1_LICENSE_FILE_LENGTH 10

class LicenseFileOperate
{
public:
    LicenseFileOperate();

    bool writeActiveFile(const QByteArray &data, const QString &filePath);
    QByteArray readActiveFile(const QString &path);

private:
    QStringList getLicenseFileData(const QByteArray &filePath);
    QVariantMap licensePackageTrans(QStringList &licenseFileData);
    void licenseDataFill(QStringList &fileData);

    struct HardWareInfo m_hardWareInfo;
    bool isPreviousSp1Version = false;
    QString m_currenServerUrl;
};

#endif // LICENSEFILEOPERA_H
